// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: ocpp/ChargingSession.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace ChargingSession {

  /// <summary>Holder for reflection information generated from ocpp/ChargingSession.proto</summary>
  public static partial class ChargingSessionReflection {

    #region Descriptor
    /// <summary>File descriptor for ocpp/ChargingSession.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static ChargingSessionReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "ChpvY3BwL0NoYXJnaW5nU2Vzc2lvbi5wcm90bxIQY2hhcmdpbmdfc2Vzc2lv",
            "bhofZ29vZ2xlL3Byb3RvYnVmL3RpbWVzdGFtcC5wcm90byKLBQoPQ2hhcmdp",
            "bmdTZXNzaW9uEhkKEWRldmljZV9pZGVudGlmaWVyGAEgASgJEh0KFWNoYXJn",
            "aW5nX3Nlc3Npb25fdXVpZBgCIAEoCRIzCg9zdGFydF9kYXRlX3RpbWUYAyAB",
            "KAsyGi5nb29nbGUucHJvdG9idWYuVGltZXN0YW1wEjYKDWVuZF9kYXRlX3Rp",
            "bWUYBCABKAsyGi5nb29nbGUucHJvdG9idWYuVGltZXN0YW1wSACIAQESFAoM",
            "Y29ubmVjdG9yX2lkGAUgASgFEhYKDnRyYW5zYWN0aW9uX2lkGAYgASgFEhMK",
            "BmlkX3RhZxgHIAEoCUgBiAEBEhMKC21ldGVyX3N0YXJ0GAggASgFEhcKCm1l",
            "dGVyX3N0b3AYCSABKAVIAogBARIbCg5yZXNlcnZhdGlvbl9pZBgKIAEoBUgD",
            "iAEBEj0KBnJlYXNvbhgLIAEoDjIoLmNoYXJnaW5nX3Nlc3Npb24uQ2hhcmdp",
            "bmdTZXNzaW9uLlJlYXNvbkgEiAEBIrkBCgZSZWFzb24SCAoETm9uZRAAEhEK",
            "DUVtZXJnZW5jeVN0b3AQARISCg5FVkRpc2Nvbm5lY3RlZBACEg0KCUhhcmRS",
            "ZXNldBADEgkKBUxvY2FsEAQSCQoFT3RoZXIQBRINCglQb3dlckxvc3MQBhIK",
            "CgZSZWJvb3QQBxIKCgZSZW1vdGUQCBINCglTb2Z0UmVzZXQQCRIRCg1Vbmxv",
            "Y2tDb21tYW5kEAoSEAoMRGVBdXRob3JpemVkEAtCEAoOX2VuZF9kYXRlX3Rp",
            "bWVCCQoHX2lkX3RhZ0INCgtfbWV0ZXJfc3RvcEIRCg9fcmVzZXJ2YXRpb25f",
            "aWRCCQoHX3JlYXNvbkJsChZjb20uY29kaWJseS5tb2RlbC5vY3BwQhRDaGFy",
            "Z2luZ1Nlc3Npb25Qcm90b8oCFkRvbWFpbk1vZGVsXFByb3RvXE9DUFDiAiJE",
            "b21haW5Nb2RlbFxQcm90b1xPQ1BQXEdQQk1ldGFkYXRhYgZwcm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::ChargingSession.ChargingSession), global::ChargingSession.ChargingSession.Parser, new[]{ "DeviceIdentifier", "ChargingSessionUuid", "StartDateTime", "EndDateTime", "ConnectorId", "TransactionId", "IdTag", "MeterStart", "MeterStop", "ReservationId", "Reason" }, new[]{ "EndDateTime", "IdTag", "MeterStop", "ReservationId", "Reason" }, new[]{ typeof(global::ChargingSession.ChargingSession.Types.Reason) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class ChargingSession : pb::IMessage<ChargingSession>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<ChargingSession> _parser = new pb::MessageParser<ChargingSession>(() => new ChargingSession());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<ChargingSession> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::ChargingSession.ChargingSessionReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSession() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSession(ChargingSession other) : this() {
      _hasBits0 = other._hasBits0;
      deviceIdentifier_ = other.deviceIdentifier_;
      chargingSessionUuid_ = other.chargingSessionUuid_;
      startDateTime_ = other.startDateTime_ != null ? other.startDateTime_.Clone() : null;
      endDateTime_ = other.endDateTime_ != null ? other.endDateTime_.Clone() : null;
      connectorId_ = other.connectorId_;
      transactionId_ = other.transactionId_;
      idTag_ = other.idTag_;
      meterStart_ = other.meterStart_;
      meterStop_ = other.meterStop_;
      reservationId_ = other.reservationId_;
      reason_ = other.reason_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSession Clone() {
      return new ChargingSession(this);
    }

    /// <summary>Field number for the "device_identifier" field.</summary>
    public const int DeviceIdentifierFieldNumber = 1;
    private string deviceIdentifier_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string DeviceIdentifier {
      get { return deviceIdentifier_; }
      set {
        deviceIdentifier_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "charging_session_uuid" field.</summary>
    public const int ChargingSessionUuidFieldNumber = 2;
    private string chargingSessionUuid_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ChargingSessionUuid {
      get { return chargingSessionUuid_; }
      set {
        chargingSessionUuid_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "start_date_time" field.</summary>
    public const int StartDateTimeFieldNumber = 3;
    private global::Google.Protobuf.WellKnownTypes.Timestamp startDateTime_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp StartDateTime {
      get { return startDateTime_; }
      set {
        startDateTime_ = value;
      }
    }

    /// <summary>Field number for the "end_date_time" field.</summary>
    public const int EndDateTimeFieldNumber = 4;
    private global::Google.Protobuf.WellKnownTypes.Timestamp endDateTime_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp EndDateTime {
      get { return endDateTime_; }
      set {
        endDateTime_ = value;
      }
    }

    /// <summary>Field number for the "connector_id" field.</summary>
    public const int ConnectorIdFieldNumber = 5;
    private int connectorId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int ConnectorId {
      get { return connectorId_; }
      set {
        connectorId_ = value;
      }
    }

    /// <summary>Field number for the "transaction_id" field.</summary>
    public const int TransactionIdFieldNumber = 6;
    private int transactionId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int TransactionId {
      get { return transactionId_; }
      set {
        transactionId_ = value;
      }
    }

    /// <summary>Field number for the "id_tag" field.</summary>
    public const int IdTagFieldNumber = 7;
    private string idTag_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string IdTag {
      get { return idTag_ ?? ""; }
      set {
        idTag_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "id_tag" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasIdTag {
      get { return idTag_ != null; }
    }
    /// <summary>Clears the value of the "id_tag" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearIdTag() {
      idTag_ = null;
    }

    /// <summary>Field number for the "meter_start" field.</summary>
    public const int MeterStartFieldNumber = 8;
    private int meterStart_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int MeterStart {
      get { return meterStart_; }
      set {
        meterStart_ = value;
      }
    }

    /// <summary>Field number for the "meter_stop" field.</summary>
    public const int MeterStopFieldNumber = 9;
    private int meterStop_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int MeterStop {
      get { if ((_hasBits0 & 1) != 0) { return meterStop_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        meterStop_ = value;
      }
    }
    /// <summary>Gets whether the "meter_stop" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasMeterStop {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "meter_stop" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearMeterStop() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "reservation_id" field.</summary>
    public const int ReservationIdFieldNumber = 10;
    private int reservationId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int ReservationId {
      get { if ((_hasBits0 & 2) != 0) { return reservationId_; } else { return 0; } }
      set {
        _hasBits0 |= 2;
        reservationId_ = value;
      }
    }
    /// <summary>Gets whether the "reservation_id" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasReservationId {
      get { return (_hasBits0 & 2) != 0; }
    }
    /// <summary>Clears the value of the "reservation_id" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearReservationId() {
      _hasBits0 &= ~2;
    }

    /// <summary>Field number for the "reason" field.</summary>
    public const int ReasonFieldNumber = 11;
    private global::ChargingSession.ChargingSession.Types.Reason reason_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::ChargingSession.ChargingSession.Types.Reason Reason {
      get { if ((_hasBits0 & 4) != 0) { return reason_; } else { return global::ChargingSession.ChargingSession.Types.Reason.None; } }
      set {
        _hasBits0 |= 4;
        reason_ = value;
      }
    }
    /// <summary>Gets whether the "reason" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasReason {
      get { return (_hasBits0 & 4) != 0; }
    }
    /// <summary>Clears the value of the "reason" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearReason() {
      _hasBits0 &= ~4;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as ChargingSession);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(ChargingSession other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (DeviceIdentifier != other.DeviceIdentifier) return false;
      if (ChargingSessionUuid != other.ChargingSessionUuid) return false;
      if (!object.Equals(StartDateTime, other.StartDateTime)) return false;
      if (!object.Equals(EndDateTime, other.EndDateTime)) return false;
      if (ConnectorId != other.ConnectorId) return false;
      if (TransactionId != other.TransactionId) return false;
      if (IdTag != other.IdTag) return false;
      if (MeterStart != other.MeterStart) return false;
      if (MeterStop != other.MeterStop) return false;
      if (ReservationId != other.ReservationId) return false;
      if (Reason != other.Reason) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (DeviceIdentifier.Length != 0) hash ^= DeviceIdentifier.GetHashCode();
      if (ChargingSessionUuid.Length != 0) hash ^= ChargingSessionUuid.GetHashCode();
      if (startDateTime_ != null) hash ^= StartDateTime.GetHashCode();
      if (endDateTime_ != null) hash ^= EndDateTime.GetHashCode();
      if (ConnectorId != 0) hash ^= ConnectorId.GetHashCode();
      if (TransactionId != 0) hash ^= TransactionId.GetHashCode();
      if (HasIdTag) hash ^= IdTag.GetHashCode();
      if (MeterStart != 0) hash ^= MeterStart.GetHashCode();
      if (HasMeterStop) hash ^= MeterStop.GetHashCode();
      if (HasReservationId) hash ^= ReservationId.GetHashCode();
      if (HasReason) hash ^= Reason.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (DeviceIdentifier.Length != 0) {
        output.WriteRawTag(10);
        output.WriteString(DeviceIdentifier);
      }
      if (ChargingSessionUuid.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(ChargingSessionUuid);
      }
      if (startDateTime_ != null) {
        output.WriteRawTag(26);
        output.WriteMessage(StartDateTime);
      }
      if (endDateTime_ != null) {
        output.WriteRawTag(34);
        output.WriteMessage(EndDateTime);
      }
      if (ConnectorId != 0) {
        output.WriteRawTag(40);
        output.WriteInt32(ConnectorId);
      }
      if (TransactionId != 0) {
        output.WriteRawTag(48);
        output.WriteInt32(TransactionId);
      }
      if (HasIdTag) {
        output.WriteRawTag(58);
        output.WriteString(IdTag);
      }
      if (MeterStart != 0) {
        output.WriteRawTag(64);
        output.WriteInt32(MeterStart);
      }
      if (HasMeterStop) {
        output.WriteRawTag(72);
        output.WriteInt32(MeterStop);
      }
      if (HasReservationId) {
        output.WriteRawTag(80);
        output.WriteInt32(ReservationId);
      }
      if (HasReason) {
        output.WriteRawTag(88);
        output.WriteEnum((int) Reason);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (DeviceIdentifier.Length != 0) {
        output.WriteRawTag(10);
        output.WriteString(DeviceIdentifier);
      }
      if (ChargingSessionUuid.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(ChargingSessionUuid);
      }
      if (startDateTime_ != null) {
        output.WriteRawTag(26);
        output.WriteMessage(StartDateTime);
      }
      if (endDateTime_ != null) {
        output.WriteRawTag(34);
        output.WriteMessage(EndDateTime);
      }
      if (ConnectorId != 0) {
        output.WriteRawTag(40);
        output.WriteInt32(ConnectorId);
      }
      if (TransactionId != 0) {
        output.WriteRawTag(48);
        output.WriteInt32(TransactionId);
      }
      if (HasIdTag) {
        output.WriteRawTag(58);
        output.WriteString(IdTag);
      }
      if (MeterStart != 0) {
        output.WriteRawTag(64);
        output.WriteInt32(MeterStart);
      }
      if (HasMeterStop) {
        output.WriteRawTag(72);
        output.WriteInt32(MeterStop);
      }
      if (HasReservationId) {
        output.WriteRawTag(80);
        output.WriteInt32(ReservationId);
      }
      if (HasReason) {
        output.WriteRawTag(88);
        output.WriteEnum((int) Reason);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (DeviceIdentifier.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(DeviceIdentifier);
      }
      if (ChargingSessionUuid.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ChargingSessionUuid);
      }
      if (startDateTime_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(StartDateTime);
      }
      if (endDateTime_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(EndDateTime);
      }
      if (ConnectorId != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(ConnectorId);
      }
      if (TransactionId != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(TransactionId);
      }
      if (HasIdTag) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(IdTag);
      }
      if (MeterStart != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(MeterStart);
      }
      if (HasMeterStop) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(MeterStop);
      }
      if (HasReservationId) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(ReservationId);
      }
      if (HasReason) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) Reason);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(ChargingSession other) {
      if (other == null) {
        return;
      }
      if (other.DeviceIdentifier.Length != 0) {
        DeviceIdentifier = other.DeviceIdentifier;
      }
      if (other.ChargingSessionUuid.Length != 0) {
        ChargingSessionUuid = other.ChargingSessionUuid;
      }
      if (other.startDateTime_ != null) {
        if (startDateTime_ == null) {
          StartDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        StartDateTime.MergeFrom(other.StartDateTime);
      }
      if (other.endDateTime_ != null) {
        if (endDateTime_ == null) {
          EndDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        EndDateTime.MergeFrom(other.EndDateTime);
      }
      if (other.ConnectorId != 0) {
        ConnectorId = other.ConnectorId;
      }
      if (other.TransactionId != 0) {
        TransactionId = other.TransactionId;
      }
      if (other.HasIdTag) {
        IdTag = other.IdTag;
      }
      if (other.MeterStart != 0) {
        MeterStart = other.MeterStart;
      }
      if (other.HasMeterStop) {
        MeterStop = other.MeterStop;
      }
      if (other.HasReservationId) {
        ReservationId = other.ReservationId;
      }
      if (other.HasReason) {
        Reason = other.Reason;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            DeviceIdentifier = input.ReadString();
            break;
          }
          case 18: {
            ChargingSessionUuid = input.ReadString();
            break;
          }
          case 26: {
            if (startDateTime_ == null) {
              StartDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(StartDateTime);
            break;
          }
          case 34: {
            if (endDateTime_ == null) {
              EndDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(EndDateTime);
            break;
          }
          case 40: {
            ConnectorId = input.ReadInt32();
            break;
          }
          case 48: {
            TransactionId = input.ReadInt32();
            break;
          }
          case 58: {
            IdTag = input.ReadString();
            break;
          }
          case 64: {
            MeterStart = input.ReadInt32();
            break;
          }
          case 72: {
            MeterStop = input.ReadInt32();
            break;
          }
          case 80: {
            ReservationId = input.ReadInt32();
            break;
          }
          case 88: {
            Reason = (global::ChargingSession.ChargingSession.Types.Reason) input.ReadEnum();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            DeviceIdentifier = input.ReadString();
            break;
          }
          case 18: {
            ChargingSessionUuid = input.ReadString();
            break;
          }
          case 26: {
            if (startDateTime_ == null) {
              StartDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(StartDateTime);
            break;
          }
          case 34: {
            if (endDateTime_ == null) {
              EndDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(EndDateTime);
            break;
          }
          case 40: {
            ConnectorId = input.ReadInt32();
            break;
          }
          case 48: {
            TransactionId = input.ReadInt32();
            break;
          }
          case 58: {
            IdTag = input.ReadString();
            break;
          }
          case 64: {
            MeterStart = input.ReadInt32();
            break;
          }
          case 72: {
            MeterStop = input.ReadInt32();
            break;
          }
          case 80: {
            ReservationId = input.ReadInt32();
            break;
          }
          case 88: {
            Reason = (global::ChargingSession.ChargingSession.Types.Reason) input.ReadEnum();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the ChargingSession message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum Reason {
        [pbr::OriginalName("None")] None = 0,
        [pbr::OriginalName("EmergencyStop")] EmergencyStop = 1,
        [pbr::OriginalName("EVDisconnected")] Evdisconnected = 2,
        [pbr::OriginalName("HardReset")] HardReset = 3,
        [pbr::OriginalName("Local")] Local = 4,
        [pbr::OriginalName("Other")] Other = 5,
        [pbr::OriginalName("PowerLoss")] PowerLoss = 6,
        [pbr::OriginalName("Reboot")] Reboot = 7,
        [pbr::OriginalName("Remote")] Remote = 8,
        [pbr::OriginalName("SoftReset")] SoftReset = 9,
        [pbr::OriginalName("UnlockCommand")] UnlockCommand = 10,
        [pbr::OriginalName("DeAuthorized")] DeAuthorized = 11,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
